class Accelerator {
	/*
	** f(t) = a*t^2 + b*t + c
	** t_0 = startingTime = 0
	** t_1 = endTime
	** f(t_0) = startingPoint
	** f(t_1) = endPoint.
	** Assume a = -1. Then, b = (delta_x/delta_t) + delta_t
	*/
	constructor(startingPoint, endPoint, endTime) {
		this.startingPoint = startingPoint;
		this.endPoint = endPoint;
		this.endTime = endTime;
	}
	square(t) {
		let delta_x = this.endPoint - this.startingPoint;
		let delta_t = this.endTime;
		return -t*t + ((delta_x/delta_t)+delta_t)*t + this.startingPoint;
	}
}

module.exports = Accelerator;
