const assert = require('assert');
const should = require('should');
const Auth = require('../services/auth');

describe(`# Auth`, function () {
	it(`constructor() should return object.`, function () {
		let auth = new Auth();
		assert.equal('object', typeof auth);
	});
	it(`creatSalt() should return random string with length of 16.`, function () {
		let auth = new Auth();
		let salt = auth.createSalt();
		assert.equal('string', typeof salt);
		assert.equal(16, salt.length);
	});
	it(`createHash(salt, password) should return random string with length of 128.`, function () {
		let auth = new Auth();
		let salt = auth.createSalt();
		let hash = auth.createHash(salt, '12345678');
		assert.equal('string', typeof hash);
		assert.equal(128, hash.length);
	});
	it(`generateJWT(secret) should return closure function.`, function () {
		let auth = new Auth();
		let generateJWT = auth.generateJWT('secret');
		assert.equal('function', typeof generateJWT);
		let jwt = generateJWT({});
		assert.equal('string', typeof jwt);
	});
	it(`generateResetToken() should return reset token.`, function (done) {
		(async function (done) {
			let auth = new Auth();
			let token = await auth.generateResetToken();
			assert.equal('string', typeof token);
			done();
		})(done);
	})
});
