const assert = require('assert');
const should = require('should');

const fns = require('../index').fns;

describe(`# fns`, function () {
	describe(`* isEmail(email)`, function () {
		it(`should return true if email param is not in email format.`, function () {
			let goodEmail = 'hoseong.a.lee@gmail.com';
			assert.equal(true, fns.isEmail(goodEmail));
		});
		it(`should return false if email param is in email format.`, function () {
			let badEmail = 'hoseong.a.lee@gmail.co2';
			assert.equal(false, fns.isEmail(badEmail));
		});
	})

	describe(`* isPassword(...args)`, function () {
		it(`should return false if password (args[0]) is less than 8 letters.`, function () {
			assert.equal(false, fns.isPassword('1234567'));
		});
		it(`should return true if password (args[0]) is equal and longer than 8 letters.`, function () {
			assert.equal(true, fns.isPassword('12345678'));
		});
		it (`should return false if password (args[0]) and confirm (args[1]) do not match.`, function () {
			assert.equal(false, fns.isPassword('12345678', '87654321'));
		});
		it (`should return true if password (args[0]) and confirm (args[1]) do match.`, function () {
			assert.equal(true, fns.isPassword('12345678', '12345678'));
		});
	});
});

