const assert = require('assert');
const should = require('should');

const services = require('../index').services;

describe(`# services`, function () {
	describe(`* Accelerator`, function () {
		let accelerator = new services.Accelerator(0, 1, 1);
		it(`should be object type when new-ed.`, function () {
			assert.equal('object', typeof accelerator);
		});
		it(`should hold right properties and values that should be same as the parameters passed when initiating.`, function () {
			accelerator.should.have.property('startingPoint', 0);
			accelerator.should.have.property('endPoint', 1);
			accelerator.should.have.property('endTime', 1);
		})
		describe(`- animate()`, function() {
			it(`should return endPoint when endTime is passed.`, function () {
				assert.equal(accelerator.animate(1), accelerator.endPoint);
			});
		});
	});
});
