const assert = require('assert');
const should = require('should');
const UserService = require('../services/user');
const UserModel = {
	build: function (data) {
		data.save = function () {};
		return data;
	},
	createSalt: function () {
		return "salt";
	},
	createHash: function (salt, password) {
		return "hash";
	},
};

describe(`# User`, function () {
	it(`constructor() should return object.`, function () {
		let $user = new UserService(UserModel);
		assert.equal('object', typeof $user);
	});
	it(`register() should return user object.`, function (done) {
		UserModel.findOne = function (where={}) {
			return null;
		};
		let $user = new UserService(UserModel);
		$user.register({
			uniqueKey: "username",
			credentialKey: "password",
			data: {
				username: "dokebi",
				password: "1234qwer",
				email: "dokebi@gmail.com",
			},
			onSuccess: (user)=>{
				assert.equal('object', typeof user)
				user.should.have.property('username');
				user.should.have.property('salt');
				user.should.have.property('hash');
				done();
			},
			onError: (err)=>{
				console.log(err);
			}
		})({}, {}, done);
	})
	it(`login() should return user object.`, function (done) {
		UserModel.findOne = function (where={}) {
			return {
				hash: "hash",
			};
		};
		let $user = new UserService(UserModel);
		let req = {body: {user: {username: "dokebi", password: "1234qwer"}}};
		$user.login({
			uniqueKey: "username",
			credentialKey: "password",
			data: {
				username: "dokebi",
				password: "1234qwer",
				email: "dokebi@gmail.com",
			},
			onSuccess: (user)=>{
				assert.equal('object', typeof user);
				done();
			},
			onError: (err)=>{
				return done(err);
			}
		})({}, {}, done);
	})
});
